/*

	show-muodon tekeminen

	optiot:
	       -s tee opiskelijaversio (student); muuten esitysversio
	       -S tee opiskelijaversio toisella tapaa

	07.12.1996 Jorma Sajaniemi; versio 0.1
	- alkuperinen versio
	09.12.1996 Jorma Sajaniemi; versio 0.2
	- ei en katko joka rivi omaksi korostusalueekseen
	10.12.1996 Jorma Sajaniemi; versio 0.3
	- alkumerkit << ja <n
	06.01.1997 Jorma Sajaniemi; versio 0.4
	- optio -s
	- molemmat alkumerkit pois supistetuista versioista
	- esitysversioon alkumerkin <\n tilalle ><
	- lopumerkki seuraava tyhje tai newline ohitetaan opiskeli-
	  jamateriaalia tehtess
	07.01.1997 Jorma Sajaniemi; versio 0.5
	- lopumerkiksi >>
	11.01.1997 Jorma Sajaniemi; versio 0.6
	- kulmien ulkopuolella <& tulostuu <
	- kulmien vliss >& tulostuu >
	25.05.1997 Jorma Sajaniemi; versio 1.0
	- korjattu negatiivisia arvoja tuottanut virhe
	- ei korostusrivej opiskelijaversioon
	01.09.1997 Jorma Sajaniemi; versio 1.1
	- listty optio S

	MUISTA MUUTTAA VERSIONUMERO ALLA
*/

#define VERSIO "1.1"

#include <stdio.h>

FILE *infile;

int optio_s = 0;
int optio_S = 0;

struct pari {
    int r1,s1,r2,s2;
    struct pari *seur;
} *aloittaja, *nykyinen;

int rivi=1,sarake=0;	/* Nykyiset */
int taso=0;		/* Salaustaso */

int ohita_tyhje_tai_nl=0;  /* Opiskelijamateriaalia tehtaessa >>:n
			      jalkeen */

void alku()
{
	nykyinen->r1 = rivi;
	nykyinen->s1 = sarake;
}

void loppu ()
{
	nykyinen->r2 = rivi;
	nykyinen->s2 = sarake;
	nykyinen->seur =
	   (struct pari *) malloc(sizeof(struct pari));
	nykyinen = nykyinen->seur;
}

void tasolle(i)
{
	if (i == 1) {
	   alku();
	} else if (! i && taso == 1) {
	   loppu();
	}
	taso = i;
}

void tulosta(c)
{
    if (optio_s ? taso < 1 : taso < 2) {
	if (c == '\n') {
		rivi++;
		sarake=0;
	} else sarake++;
	if (! ohita_tyhje_tai_nl || ! (c == ' ' || c == '\n'))
	     putchar(c);
	ohita_tyhje_tai_nl = 0;
    }
}

/********** Pohjelma ***********************************************/

main (argc,argv)
int argc;
char ** argv;
{
    char * arg;       /* kasiteltava argumentti */
    char c,c1;

    aloittaja = (struct pari *) malloc(sizeof(struct pari));
    nykyinen = aloittaja;

    infile = stdin; /* Ellei optioista muuta seuraa */

    /* Komentorivioptiot */

    for (arg = *(++argv); arg; arg = *(++argv)) {
      switch (*arg) {
      case '-' :


    	switch (* ++arg) {
    	case 's': optio_s++; break;
    	case 'S': optio_s++; optio_S++; break;
    	default:  printf(
    		     "\nteeshow (version %s): Unknown option %s\n\n",
    		      VERSIO,arg);
    		  exit(1);
    	}
	break;
      default:	if ((infile = fopen(arg,"r")) == NULL) {
		   fprintf(stderr,"teeshow: file %s does not open\n",arg);
		   exit(1);
      		}
      		break;
      }
    }

    while ((c= getc(infile)) != EOF) {
	if (taso == 0 && c == '<') {
	    c= getc(infile);  /* Tuskin on EOF */
	    if (c == '<') {
	    	tasolle(1);
	    } else if (c == '\n') {
		if (!optio_s) {tulosta('>'); tulosta('<');}
	    	tasolle(2);
	    } else {
		tulosta('<');
	    	if (c != '&') tulosta(c);
	    }
	}
	else if (taso && c == '>') {
	    c= getc(infile);  /* Tuskin on EOF */
	    if (c == '>') {
	        tasolle(0);
	        if (optio_s && ! optio_S) ohita_tyhje_tai_nl++;
	    } else {
	        tulosta('>');
		if (c != '&') tulosta(c);
	    }
	} else tulosta(c);
    }

    /* Korostustiedot */

    if (! optio_s && nykyinen != aloittaja) {
    	printf("#$#$#$x#$#$#$\n");
	while (aloittaja != nykyinen) {
	    printf("%d.%d %d.%d\n",aloittaja->r1,aloittaja->s1,
	    	aloittaja->r2,aloittaja->s2);
	    aloittaja = aloittaja->seur;
	}
    }

    exit(0);
}
